#include <nds.h>

#include "md.h"
#include "anorms_bin.h"
#include "../gl/glRoutines.h"

u32 * anorms_u32 = (uint32 *) anorms_bin;

int getNumFrames (const u8 * md2file) {
	mdl2_header_t * md2header = (mdl2_header_t *) md2file;
	return md2header->num_frames;
}

int loadMD2Frame(const u8 * md2file, int frame)
{
	mdl2_header_t * md2header; //size is 68
	frame_t * nds_frame;
	long *command;
	int vertnum;
	int type;
	int i;
	int vert_index;
	
	vert_nds vert_list[64];
	
	//Open md2 file
	md2header = (mdl2_header_t *) md2file;
	
	// Locate frame
	nds_frame = (frame_t *) (md2file + md2header->ofs_frames + (md2header->framesize * frame));
	
	// Scale and Translate
	glScalef32(floatof32(nds_frame->scale[0]),floatof32(nds_frame->scale[2]),floatof32(nds_frame->scale[1]));
	MATRIX_TRANSLATE = -(128 << 6);
	MATRIX_TRANSLATE = -(128 << 6);
	MATRIX_TRANSLATE = -(128 << 6);

	// Set gl command starting address
	command = (long *)(md2file + md2header->ofs_glcmds);
	
	while ((*command) != 0)
	{
		if ((*command) > 0)
			{vertnum = *command; command++; type = 0;}	
		else
			{vertnum = - (*command); command++; type = 1;}

		for (i=0;i<vertnum;i++)
		{
			vert_list[i].v = *((float*)command); command++;
			vert_list[i].u = *((float*)command); command++;
            
			vert_index = *command; command++;
			
			vert_list[i].x = nds_frame->verts[vert_index].v[0] << 0;
			vert_list[i].z = nds_frame->verts[vert_index].v[1] << 0;
			vert_list[i].y = nds_frame->verts[vert_index].v[2] << 0;
			vert_list[i].n = anorms_u32[nds_frame->verts[vert_index].lightnormalindex];
		}

		if (type==0)
		{
			glBegin (GL_TRIANGLE_STRIP);
			for (i=0;i<vertnum;i++)
			{
				glTexCoord2f32(floatof32(vert_list[i].u), floatof32(vert_list[i].v));
				glNormal( vert_list[i].n );
				GFX_VERTEX10 = NORMAL_PACK(vert_list[i].x,vert_list[i].y,vert_list[i].z);		
			}
			glEnd();
		}
		else
		{
			glBegin (GL_TRIANGLE_STRIP);
			glTexCoord2f32(floatof32(vert_list[0].u), floatof32(vert_list[0].v));
			glNormal( vert_list[0].n );
			GFX_VERTEX10 = NORMAL_PACK(vert_list[0].x,vert_list[0].y,vert_list[0].z);		
			i = 1;
			while (i < vertnum) {
				glTexCoord2f32(floatof32(vert_list[i].u), floatof32(vert_list[i].v));
				glNormal( vert_list[i].n );
				GFX_VERTEX10 = NORMAL_PACK(vert_list[i].x,vert_list[i].y,vert_list[i].z);
				i++;
				if (i >= vertnum) break;
				glTexCoord2f32(floatof32(vert_list[i].u), floatof32(vert_list[i].v));
				glNormal( vert_list[i].n );
				GFX_VERTEX10 = NORMAL_PACK(vert_list[i].x,vert_list[i].y,vert_list[i].z);
				i++;	
				if (i >= vertnum) break;			
				glTexCoord2f32(floatof32(vert_list[0].u), floatof32(vert_list[0].v));
				glNormal( vert_list[0].n );
				GFX_VERTEX10 = NORMAL_PACK(vert_list[0].x,vert_list[0].y,vert_list[0].z);
			}
			glEnd();
		}
	}

	return 1;	
}
